/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
   // Application Constructor
   initialize: function () {
      try {
         cordova.addConstructor();
      } catch (e) {
         cordova = {};
         dn.devready = 1;
         dn.init();
      }
      this.bindEvents();
   },
   // Bind Event Listeners
   //
   // Bind any events that are required on startup. Common events are:
   // 'load', 'deviceready', 'offline', and 'online'.
   bindEvents: function () {
      document.addEventListener('deviceready', app.onDeviceReady, false);
   },
   // deviceready Event Handler
   //
   // The scope of 'this' is the event. In order to call the 'receivedEvent'
   // function, we must explicity call 'app.receivedEvent(...);'
   onDeviceReady: function () {
      dn.devready = 1;
      dn.init();
   },
   // Update DOM on a Received Event
   receivedEvent: function (id) {
   }
};

dn = {
   debug: 0,
   inited: 0,
   devready: 0,
   docready: 0,
   categories: new Array(),
   articles: new Array(),
   _loadhtml: '<center class="lding"><img src="css/images/load.png" class="loadingimg" style="width: 30px" alt="" /> Betöltés...</center>',
   foreground: 0,
   GCMCode: "938144930502",
   todisplay: false,
   lmswiper: false,
   adBannerPlaceReady: function() {
      window.plugins.AdMob.requestAd(null, dn.adBannerReady);
   },   
   adBannerReady: function() {
      window.plugins.AdMob.showAd(true);
   },
   adsInit: function(reinit){        
      if ( window.plugins && window.plugins.AdMob ) {
            dn.ad_units = {
                ios : {
                    banner: 'ca-app-pub-3712483331672586/2394668403',
                    interstitial: 'ca-app-pub-3712483331672586/3871401607'
                },
                android : {
                    banner: 'ca-app-pub-6220007399327534/5246488577',
                    interstitial: 'ca-app-pub-6220007399327534/6723221771'
                }
            };
            dn.admobid = ( /(android)/i.test(navigator.userAgent) ) ? dn.ad_units.android : dn.ad_units.ios;
            
            window.plugins.AdMob.setOptions( {
                publisherId: dn.admobid.banner,
                interstitialAdId: dn.admobid.interstitial,
                bannerAtTop: false,
                overlap: false,
                autoShow: true,
                position: window.plugins.AdMob.AD_SIZE.AD_POSITION,
                adSize: window.plugins.AdMob.AD_SIZE.SMART_BANNER
             });
             //window.plugins.AdMob.createBannerView();
        } else {
           if (!dn.adsreinited) {
               dn.adsreinited = 1;
               document.addEventListener('deviceready', dn.adsInit, false);
            }
        }
   },
   loadarticle: function () {

   },
   nav: {
      init: function () {
         $('a').each(function () {
            href = $(this).attr('href');
            if (href.substr(0, 1) == '#') {

            }
         })
      }
   },
   initPush: function () {
      try {
         DNpush.DNpushAppId = "DMu9QNOAjOXPC3d20bis";

         DNpush.Common.OnPushReceived(dn.gotPush);

         if (DNpush.Common.GetCurrentOs() == DNpush.OS.ANDROID) {
            DNpush.GCM.Register(dn.GCMCode,
                    {
                       successCallback: function (pushresult) {
                          dn.foreground = 1;
                       },
                       failCallback: function (pushresult) {
                       }
                    });
         } else if (DNpush.Common.GetCurrentOs() == DNpush.OS.IOS) {
            DNpush.APNS.Register(
                    {
                       successCallback: function (pushresult) {
                                 dn.foreground = 1;
                       },
                       failCallback: function (pushresult) {
                       }
                    });
         } else {
            //Console.log("Not supported platform");
         }
      } catch (e) {
      }
      ;
   },
   sshowAd: 0,
   gotPush: function (d) {
       console.log('GotPush: ',d, dn.foreground);
       document.lpush = d;
       document.lpf = dn.foregound;
      if (dn.foreground) {
         if (d.notification.Data.type == "article") {
            $('#alert .alert-title').html(d.notification.Title);
            $('#alert .alert-text').html(d.notification.Alert);
            $('#alert').attr('data-type', 'article').attr('data-id', d.notification.Data.id).addClass('show');
         }
      } else {
         dn.openedpush = 1;
         if (dn.phistory.length < 1) {
            dn.phistory[0] = {
               "type": "category",
               "id": "0"
            }
         }
         if (d.notification.Data.showAd) {
            dn.sshowAd = 1;
            window.plugins.AdMob.createInterstitialView();
            window.plugins.AdMob.requestInterstitialAd(); 
         }
         if (d.notification.Data.type == "article") {
            dn.article(d.notification.Data.id, 1);
         }
         if (d.notification.Data.type == "category") {
            dn.category(d.notification.Data.id, 1);
         }
      }
   },
   cb: function (e) {
      //   console.log(e);
   },
   onFileSystemSuccess: function (e) {
      //   console.log(e);
      dn.fileSystem = e;
      dn.fileSystem.root.getDirectory("Android", {create: true}, dn.cb, dn.cb);
      dn.fileSystem.root.getDirectory("Android/data", {create: true}, dn.cb, dn.cb);
      dn.fileSystem.root.getDirectory("Android/data/com.domenet.drtihanyicom", {create: true}, dn.fsInitComp, null);
   },
   Dir: false,
   fsInitComp: function (dir) {
      if (dir.fullPath)
         dn.Dir = dir;
   },
   extendloading: 0,
   extended: 0,
   loadExtend: function() {
      if (dn.extendloading)
         return 0;
      dn.extendloading = _ts();
      dn.extendLoader = $.ajax({
         url: "http://drtihanyi.com/appExtend.js",
         dataType: "script",
         success: function() {
         },
         error: function(e,f,g) {
            //alert(JSON.stringify(e) + "\n" + f + "\n" + g);
         }
      });
      dn.extendTimer = setTimeout('dn.extendRun(1)', 20500);
   },
   extendTimer: 0,
   extendRun: function(byTimeout) {
      clearTimeout(dn.extendTimer);
      if (byTimeout) {
         if (dn.extendloading + 20000 < _ts()) {
            dn.extended = 2;
            console.log('Extending failed with timeout...');
         } else {
            return dn.extendTimer = setTimeout('dn.extendRun(1)', 1000);
         }
      } else {
         dn.extended = 1;
      }
      dn.init();
   },
   sendStatistic: function() {
      try {
         $.ajax({
            dataType: "JSONP",
            url: "http://apk.drtihanyi.com/news/appStart",
            data: {
               platform: device.platform,
               model: device.model,
               uuid: device.uuid,
               pl_version: device.version
            }
         })
      } catch(e) {}
   },
   init: function () {
      if (!dn.extendloading)
         dn.loadExtend();
      if (!dn.devready || !dn.docready || dn.inited || !dn.extended) {
         if (dn.docready) {
            this.resize();
            this.htmlinit();
         }
         return false;
      }
      dn.openedpush = 0;
      try {
         dn.adsInit();
         window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, dn.onFileSystemSuccess, dn.cb);
         DNpush.Common.OnPushReceived(dn.gotPush);
         analytics.startTrackerWithId('UA-55341324-1');
      } catch (e) {};
      dn.inited = 1;
      db.init();
      dn.initStampCache();
      dn.initCatCache();
      dn.resize();
      dn.htmlinit();
      $(window).resize(function () {
         dn.resize();
      });
      //document.addEventListener("resume", dn.resume, false);
      //alert(navigator.userAgent);
      var version = " " + navigator.userAgent.match(/Android\s+([\d\.]+)/);
      var spos = version.indexOf('droid 1') > 0 ? version.indexOf('droid 1') : version.indexOf('droid 2');
      if (spos > 1) { /* Old Android, needs scroll fix */
         dn.olddroid = true;
      }
      try {
         window.plugins.webintent.getUri(function (url) {
            return dn.openedurl(url);
         });
         window.plugins.webintent.onNewIntent(function (url) {
            return dn.openedurl(url);
         }, function () {
         });

      } catch (e) {}
      
      dn.sendStatistic();
      
      if (dn.suptime < _ts() - 2000) {
         dn.hideStart();
      } else {
         setTimeout('dn.hideStart()', 1000);
      }
   },
   openedurl: function (url) {
      if (!url)
         return 0;
      if (url.indexOf('fromsca=2')) {
         dn.fromApp = 1;
      }
      if (url.indexOf('?') > 0)
         url = url.substr(0,url.indexOf('?'));
      if (url.indexOf('#') > 0)
         url = url.substr(0,url.indexOf('#'));
      if (url) {
         var data = url.split('/');
         if (data[data.length - 2] == 'cikk') {
            dn.openedpush = 1;
            dn.getArtID(data[data.length - 1]);
         }
      }
   },
   hideStart: function () {
      if (!dn.openedpush) {
         dn.category("__newest", 1);
      }
      //navigator.splashscreen.show();
   },
   hideLeftPanel: function (force) {
      if (!$('#menu').hasClass('open'))
         return 0;
      if (force) {
         $('body').removeClass('lmopen').addClass('lmforceclose');
      } else {
         $('body').removeClass('lmopen').addClass('lmclose');
      }
      $('#menu').removeClass('open');
   },
   showLeftPanel: function () {
      if ($('#menu').hasClass('open'))
         return 0;
      $('body').removeClass('lmforceclose').removeClass('lmclose').addClass('lmopen');
      $('#menu').addClass('open');
   },
   gotSettings: function () {
      try {
         if (dn.settings.push) {
            if (dn.settings.push == "on") {
               dn.initPush();
               $('#allowPush').addClass('on');
            } else {
               $('#allowPush').addClass('off');
               try {
                  DNpush.GCM.UnRegister(dn.cb, dn.cb);
               } catch (e) {
               }
            }
         } else {
            db.insert('settings', {'id': 'push', 'value': "on"});
            $('#allowPush').addClass('on');
            dn.initPush();
         }
         if (dn.settings.debug) {
             dn.debugmode = dn.settings.debug;
         }
              
      } catch (e) {
         //alert('Not yet set');
      }
      dn.loadExternal();
   },
   loadExternal: function() {
      
   },
   initLinks: function (force) {
      if (force) {
         $('.initedLink').removeClass('initedLink');
      }
      $('a:not(.initedLink), alink:not(.initedLink)').each(function () {
         if ($(this).attr('data-type') == "category") {
            $(this).unbind().click(function (e) {
               dn.category($(this).attr('data-id'));
               e.preventDefault();
            }).addClass('initedLink');
         } else if ($(this).attr('data-type') == "article") {
            $(this).unbind().click(function (e) {
               dn.article($(this).attr('data-id'));
               e.preventDefault();
            }).addClass('initedLink');
         }
      });
      $('.sh-article:not(.initedLink)').each(function () {
         if ($(this).attr('data-type') == "article") {
            $(this).unbind().click(function () {
               dn.article($(this).attr('data-id'));
            }).addClass('initedLink');
         }
      })
   },
   catCache: new Array(),
   initCatCache: function () {
      db.get('news_catlab', 1, Array(), dn._initCatCache);
   },
   _initCatCache: function (d) {
      for (var i = 0; i < d.rows.length; i++) {
         dn.catCache[d.rows.item(i).id] = d.rows.item(i).name;
      }
   },
   initStampCache: function () {
      db.get('news', '1', Array(), dn._initStampCache);
   },
   _initStampCache: function (data) {
      for (var i = 0; i < data.rows.length; i++) {
         if (data.rows.item(i).lstamp)
            dn.artStampsCache[data.rows.item(i).id] = data.rows.item(i).lstamp;
      }
   },
   pauseApp: function () {
      dn.foreground = 0;
   },
   resumeApp: function () {
      dn.foreground = 1;
      window.plugins.webintent.getUri(function (url) {
         if (url) {
            var data = url.split('/');
            if (data[data.length - 2] == 'cikk') {
               dn.openedpush = 1;
               dn.getArtID(data[data.length - 1]);
            }
         }
      });
      window.plugins.webintent.onNewIntent(function (url) {
         if (url) {
            var data = url.split('/');
            if (data[data.length - 2] == 'cikk') {
               dn.openedpush = 1;
               dn.getArtID(data[data.length - 1]);
            }
         }
      }, function () {
      });
      dn.resize();
   },
   menub: function() {
         if ($('#menu').hasClass('open')) {
            dn.hideLeftPanel();
         } else {
            dn.showLeftPanel();
         }
   },
   htmlinit: function () {
      document.addEventListener('touchstart', touches.start, false);
      document.addEventListener('touchmove', touches.move, false);
      document.addEventListener('touchend', touches.end, false);
      document.addEventListener('mousedown', touches.start, false);
      document.addEventListener('mouseup', touches.end, false);
      document.addEventListener("backbutton", dn.back, false);
      document.addEventListener("menubutton", dn.menub, false);
      document.addEventListener("pause", dn.pauseApp, false);
      document.addEventListener("resume", dn.resumeApp, false);
      $('#alert .close').unbind().click(function () {
         $('#alert').removeClass('show');
      })
      $('#alert .alert-title, #alert .alert-text').unbind().click(function () {
         if ($('#alert').attr('data-type') == "article")
            dn.article($('#alert').attr('data-id'));
         $('#alert').removeClass('show');
      })
      $('#menu').unbind().click(function (e) {
         dn.menub();
         e.preventDefault();
      })
      $('#back').unbind().click(function (e) {
         dn.back(2);
         e.preventDefault();
      })
      touches.sr = function () {
         dn.showLeftPanel();
      }
      touches.sl = function () {
         dn.hideLeftPanel();
      };
      touches.sd = function () {
         if ($('#menu').hasClass('open') || $('body').hasClass('updopen'))
            return 0;
         $('body').removeClass('updclose').addClass('updopen');
         dn._showTopUpdTime = _ts();
         dn.updatePage();
      };
      dn.initLinks();
      $('#allowPush.onoff').unbind().click(function (e) {
         if ($(this).hasClass('on')) {
            $(this).addClass('off').removeClass('on');
            db.insert('settings', {'id': 'push', 'value': "off"});
            try {
               DNpush.GCM.UnRegister(dn.cb, dn.cb);
            } catch (e) {
            }
         } else {
            $(this).addClass('on').removeClass('off');
            db.insert('settings', {'id': 'push', 'value': "on"});
            try {
               DNpush.GCM.Register(dn.GCMCode,
                       {
                          successCallback: function (pushresult) {
                             dn.foreground = 1;
                          },
                          failCallback: function (pushresult) {
                          }
                       });
            } catch (e) {
            }
         }
      });
      $('#searchb').unbind().click(function (e) {
         e.preventDefault();
         dn.search();
      });
      $('#searchf').unbind().submit(function (e) {
         e.preventDefault();
         dn.search();
      });
     /* try {
         dn.lmswiper.reInit();
      } catch(e) {};*/
      if (!dn.lmswiper) {
         dn.lmswiper = new Swiper('.lmswiper', {
            scrollbar: '.lmswiper .swiper-scrollbar',
            slidesPerView: 'auto',
            scrollbarHide: false,
            mousewheelControl: true,
            centeredSlides: false,
            simulateTouch: true,
            freeMode: true,
            loop: false,
            direction: 'vertical'
         });
      }
      
      
   },
   lw: 0,
   lh: 0,
   resize: function () {
      if (($(window).width() > dn.lw && $(window).height() < dn.lh) ||
              ($(window).width() < dn.lw && $(window).height() > dn.lh)) {
         try {
            gAdmob.killAd();
            gAdmob.addBanner(false);
         } catch (e) {
         }
      }
      dn.hideLeftPanel(1);
      if ($(window).height() != dn.lh) {
         $("#page").height($(window).height());
         $("#main").height($(window).height() - 60);
         $("#leftpanel, #leftpanelin").height($(window).height()-50);
         $("#leftpanel .lmswiper").height($('#leftpanel').height() - 126);
      }
      if ($(window).width() != dn.lw) {
         $("#page").width($(window).width());
      }
      dn.lw = $(window).width();
      dn.lh = $(window).height();
   },
   exturl: function (url) {
      cordova.exec(null, null, "InAppBrowser", "open", [url, "_system"]);
   },
   updatePage: function () {
      if (dn.curpage.type == "category") {
         dn.category(dn.curpage.id, 1);
      } else if (dn.curpage.type == "article") {
         dn.article(dn.curpage.id, 1);
      }
   },
   hideTopUpd: function () {
      if ((_ts() - dn._showTopUpdTime) < 1000)
         setTimeout(function () {
            $('body').removeClass('updopen').addClass('updclose');
         }, 500);
      else
         $('body').removeClass('updopen').addClass('updclose');
   },
   receivedPush: function (e) {

   },
   recCat: function (d, server) {
      if (server) {
         db.insert('datastatus', {
            'id': 'c' + d.id,
            'updated': _ts()
         });
         for (var i in d.ids) {
            db.insert('news_catlab_index', {
               'id': d.id + '_' + d.ids[i],
               'cid': d.id,
               'nid': d.ids[i]
            });
         }
         db.insert('news_catlab', {
            "id": d.id,
            "name": d.category.name
         })
         if (d.id == "__newest")
            d.id = 0;
         dn.catCache[d.id] = d.category.name;
         for (var i in d.nodes) {
            db.update('news', {
               'id': d.nodes[i].id,
               'title': d.nodes[i].title,
               'stamp': d.nodes[i].stamp,
               'description': d.nodes[i].description,
               'approved': d.nodes[i].approved,
               'time': d.nodes[i].time,
               'uri_id': d.nodes[i].uri_id
            }, 'id = ?', d.nodes[i].id);
            //dn.saveStamp('article',d.nodes[i].id,d.nodes[i].stamp);
         }
      }
      if (d.id == "__newest")
         d.id = 0;
      if (!d.category)
         d.category = {
            "name": dn.catCache[d.id]
         };
      dn.categories[d.id] = {
         "name": d.category.name,
         "nodes": d.nodes
      }
      dn.display();
   },
   recArt: function (d, server) {
      if (server) {
         db.insert('datastatus', {
            'id': 'a' + d.id,
            'updated': _ts()
         });
         db.update('news', {
            'id': d.article.id,
            'title': d.article.title,
            'stamp': d.article.stamp,
            'description': d.article.description,
            'approved': d.article.approved,
            'comments': d.article.commets,
            'shares': d.article.shares,
            'body': d.article.body,
            'uri_id': d.article.uri_id,
            'author': d.article.author
         }, 'id = ?', d.article.id);
      }
      dn.articles[d.id] = d.article;
      dn.display();
   },
   search: function () {
      var kw = $('#keyword').val();
       if (kw == "debugapp") {
           dn.debugmode = 1;
           db.insert('settings', {'id': 'debug', 'value': 1});
           alert('Debug mode on');
           return 0;
       }
      $('#keyword').blur();
      kw = kw.replace(/[^a-zA-Z0-9\s!?áÁéÉíÍóÓöÖőŐúÚüÜűŰ]+/g, '');
      if (kw.length >= 3) {
         dn.kw = kw;
         dn.category(_ts());
      }
   },
   tdid: 0,
   category: function (id, forceUpdate) {
      if (id == 0) {
         id = "__newest";
      }
      if (dn.openedpush && dn.sshowAd) {
         window.plugins.AdMob.showInterstitialAd();
         dn.tdid = id;
         dn.openedpush = 0;
         dn._tdtimer = setTimeout('dn.category(dn.tdid)', 2000);
         return 0;
      }
      dn.curpage.html = $('#mainin').html();

      if (!dn.todisplay || forceUpdate) {
         dn.todisplay = {
            'type': 'category',
            'id': id == "__newest" ? 0 : id,
            'update': forceUpdate
         };
         dn.hideLeftPanel();
         if (!forceUpdate) {
            $('#mainin').html(dn._loadhtml);
         }
      }
      ;
      if (forceUpdate) {
         dn.getCatFromServer(id);
      } else
         dn.checkData('category', id);
   },
   getArtID: function (uri_id) {
      db.get('news', 'uri_id = ?', Array(uri_id), dn.gotArtId, {"uri_id": uri_id});
   },
   gotArtId: function (data, vals, od) {
      console.log(data.rows.item(0));
      if (data.rows.length == 1)
         dn.article(data.rows.item(0).id, 1);
      else
         dn.article(od.uri_id);
   },
   article: function (id, forceUpdate) {
      dn.curpage.html = $('#mainin').html();
      if (!this.todisplay || forceUpdate) {
         this.todisplay = {
            'type': 'article',
            'id': id,
            'update': forceUpdate
         };
         dn.hideLeftPanel();
         if (!forceUpdate) {
            $('#mainin').stop(true).addClass('leftout').delay(500).queue(function () {
               $('#mainin').html(dn._loadhtml).removeClass('leftout');
            })
         }
      }
      ;
      if (forceUpdate) {
         this.getArtFromServer(id);
      } else
         this.checkData('article', id);
   },
   getArtFromServer: function (id) {
      if (id) {
         $.ajax({
            url: 'http://apk.drtihanyi.com/news/article/' + id,
            success: function (d) {
               if (d.type == "article") {
                  dn.recArt(d, 1);
               }
            },
            dataType: 'JSONP'
         })
      }
   },
   getCatFromServer: function (id) {
      if (id) {
         $.ajax({
            url: 'http://apk.drtihanyi.com/news/mobilecat/' + id,
            data: {
               kw: dn.kw
            },
            success: function (d) {
               if (d.type == "category") {
                  dn.recCat(d, 1);
               }
            },
            dataType: 'JSONP'
         })
      }
   },
   getCatFromSQL: function (id) {
      db.get('news_catlab_index', 'cid = ?', id, dn.gotCatListFromSQL, {'cid': id});
   },
   gotCatListFromSQL: function (data, vals, od) {
      var sqlstr = "";
      var sqlvals = Array();
      for (var i = 0; i < data.rows.length; i++) {
         sqlstr += " OR id = ?";
         sqlvals[sqlvals.length] = data.rows.item(i).nid;
      }
      sqlstr = '(' + sqlstr.substr(4) + ') AND approved > ?';
      sqlvals[sqlvals.length] = 0;
      db.get('news', sqlstr + ' ORDER BY time DESC', sqlvals, dn.gotCatFromSQL, od);
   },
   gotCatFromSQL: function (data, vals, od) {
      var nodes = new Array();
      var row = {};
      //console.log(data);
      for (var i = 0; i < data.rows.length; i++) {
         row = data.rows.item(i);
         nodes[nodes.length] = {
            "id": row['id'],
            "title": row['title'],
            "description": row['description'],
            "approved": row['approved'],
            "stamp": row['stamp'],
            "lstamp": row['lstamp']
         };
      }
      //console.log('Cat data from SQL:', nodes, vals, od);
      dn.recCat({
         "nodes": nodes,
         "id": od.cid
      });
   },
   getArtFromSQL: function (id) {
      db.get('news', 'id = ? AND approved > ?', Array(id, 1), dn.gotArtFromSQL);
   },
   gotArtFromSQL: function (data, vals) {
      //console.log(data.rows.item(0));
      dn.recArt({
         "article": data.rows.item(0),
         "id": vals[0]
      });
   },
   checkData: function (t, id) {
      if (t == "category") {
         t = "c";
      } else if (t == "article") {
         t = "a";
      }
      db.get('datastatus', 'id = ?', t + id, dn.checkedData);
   },
   checkedData: function (res, vals) {
      var dtype = vals[0].substr(0, 1);
      var id = vals[0].substr(1);
      if (res && res.rows.length > 0) {
         var row = res.rows.item(0);
         if (row.id.substr(0, 1) == "c" && row.updated > (_ts() - (60 * 60 * 1000))) {
            if ((row.id.substr(1) == "__newest" && dn.categories[0]) || dn.categories[row.id.substr(1)]) {
               //alert('Data is in Cache');
               //dn.getCatFromSQL(row.id.substr(1));
               dn.display();
            } else {
               //console.log('Get category from SQL');
               dn.getCatFromSQL(row.id.substr(1));
            }
         } else if (row.id.substr(0, 1) == "a" && row.updated > (_ts() - (24 * 60 * 60 * 1000))) {
            //      console.log('GetArtFromSQL because stored data is up to date');
            dn.getArtFromSQL(row.id.substr(1));
         } else {
            if (dtype == "c") {
               dn.getCatFromServer(vals[0].substr(1));
            } else if (dtype == "a") {
               //         console.log('GetArtFromSERVER because stored data is old');
               dn.getArtFromServer(vals[0].substr(1));
            }
         }
      } else {
         if (dtype == "c") {
            dn.getCatFromServer(vals[0].substr(1));
         } else if (dtype == "a") {
            dn.getArtFromServer(vals[0].substr(1));
         }
      }
   },
   phistory: new Array(),
   curpage: false,
   display: function (fromTimeout) {
      $('#mainin').stop(true).removeClass('leftout').removeClass('backout');
      clearTimeout(dn.dt);
      dn.hideTopUpd();
      if (dn.todisplay) {
         try {
            analytics.trackView(dn.todisplay.type+'/'+dn.todisplay.id);
         } catch(e) {};
         if (!dn.todisplay.update || !dn.curpage) {
            if (dn.curpage) {
               dn.curpage.scrollTop = $('body').scrollTop();
               if (dn.curpage.id != dn.todisplay.id)
                  dn.phistory[dn.phistory.length] = dn.curpage;
               $('#back').removeClass('inactive');
            }
            dn.curpage = dn.todisplay;
         }
         if (dn.todisplay.type == "category") {
            if (dn.categories[dn.todisplay.id]) {
               dn.renderCat(dn.categories[dn.todisplay.id]);
            } else {
               dn.dt = setTimeout('dn.display(1)', 100);
               return 0;
            }
         } else if (dn.todisplay.type == "article") {
            if (dn.articles[dn.todisplay.id]) {
               dn.renderArt(dn.articles[dn.todisplay.id]);
               dn.articles = new Array();
            } else {
               dn.dt = setTimeout('dn.display(1)', 100);
               return 0;
            }
         }
         // $('#main img').click(function() {alert($(this).attr('src'))});
      }
   },
   lbc: 0,
   back: function (button) {
      if (dn.phistory.length == 1)
         $('#back').addClass('inactive');

      if (dn.phistory.length == 0 && button === 2)
         return 1;

      if (dn.phistory.length == 0) {
         if (dn.fromApp)
            return navigator.app.exitApp();
         if (dn.olddroid) {
            if (confirm('Biztosan ki akar lépni?'))
               return navigator.app.exitApp();
         } else {
            navigator.notification.confirm('Biztosan ki akar lépni?', function(r){if (r=="1") {return navigator.app.exitApp()}},"Megerősítés","Kilépés,Mégsem");
            return 1;
         }
      }
      dn.todisplay = dn.phistory.pop();
      if (dn.todisplay.html) {
         //alert('Load from HTML cache');
         dn.hideLeftPanel();
         $('#mainin').stop(true).removeClass('leftout').addClass('backout');
         dn.curpage = dn.todisplay;
         dn.todisplay = false;
         $('#mainin').delay(300).queue(function () {
            $('#mainin').html(dn.curpage.html).removeClass('backout');
            dn.checkStamps();
            dn.initLinks(1);
            //dn.pageScrollBar();
         });
      } else {
         if (dn.todisplay.type == "category") {
            dn.category(dn.todisplay.id);
         } else if (dn.todisplay.type == "article") {
            dn.article(dn.todisplay.id);
         }
      }
   },
   pageScrollBar: function() {
     /* if (dn.pageScroll) {
         dn.pageScroll.slideTo(0,1);
         dn.pageScroll.destroy();
      }
         dn.pageScroll = new Swiper('#page', {
            scrollbar: '.page-scrollbar',
            slidesPerView: 'auto',
            scrollbarHide: true,
            mousewheelControl: true,
            centeredSlides: false,
            simulateTouch: true,
            freeMode: true,
            loop: false,
            direction: 'vertical'
         });*/
   },
   renderCat: function (category) {
      this.todisplay = false;
      if (!category.name)
         category.name = "Legfrissebb tanulmányok";
      var rstr = "<h3>" + category.name + "</h3>";
      for (var i in category.nodes) {
         var t = $('<alink />', {
            'class': 'sh-title',
            'html': category.nodes[i].title,
            'data-type': 'article',
            'data-id': category.nodes[i].id
         });
         var img = Array();
         img[0] = {outerHTML: ''};
         if (dn.artStampsCache[category.nodes[i].id]) {
            img = $('<img />', {
               'src': dn.artStampsCache[category.nodes[i].id],
               'class': 'sh-stamp loaded ast' + category.nodes[i].id,
               'data-id': category.nodes[i].id,
               'data-type': "article",
               'data-stamp': category.nodes[i].stamp
            });
         } else if (category.nodes[i].lstamp) {
            img = $('<img />', {
               'src': category.nodes[i].lstamp,
               'class': 'sh-stamp loaded ast' + category.nodes[i].id,
               'data-id': category.nodes[i].id,
               'data-type': "article",
               'data-stamp': category.nodes[i].stamp
            });
         } else if (category.nodes[i].stamp) {
            img = $('<img />', {
               'src': 'img/load.gif',
               'class': 'sh-stamp ast' + category.nodes[i].id,
               'data-id': category.nodes[i].id,
               'data-type': "article",
               'data-stamp': category.nodes[i].stamp
            });
         }
         var a = $('<div />', {
            'class': 'sh-desc',
            'html': img[0].outerHTML + category.nodes[i].description,
            'data-type': 'article',
            'data-id': category.nodes[i].id
         });
         var d = $('<div />', {
            'class': 'sh-article',
            'html': t[0].outerHTML + a[0].outerHTML,
            'data-type': 'article',
            'data-id': category.nodes[i].id
         });
         rstr += d[0].outerHTML;
      }
      $('#mainin').stop(true).html(rstr).removeClass('leftout');
      $('body').scrollTop(0);
      dn.checkStamps();
      this.initLinks();
      if (dn.curpage.update) {
         dn.curpage.html = $('#mainin').html();
      }
      $('#page').scrollTop(0);
      $('#header .share').attr('title', category.name);
      $('#header .share').attr('data-url', "http://drtihanyi.com");
      $('#header .share').unbind().click(function () {
         window.plugins.socialsharing.share($(this).attr('title'), $(this).attr('title'), null, $(this).attr('data-url'));
      })
   },
   renderArt: function (article) {
      this.todisplay = false;
      var rstr = "";
      var t = $('<alink />', {
         'class': 'sh-title',
         'html': article.title,
         'data-type': 'news',
         'data-id': article.id
      });
      var a = $('<div />', {
         'class': 'sh-desc',
         'html': article.body,
         'data-type': 'news',
         'data-id': article.id
      });
      var d = $('<div />', {
         'class': 'article',
         'html': t[0].outerHTML + a[0].outerHTML,
         'data-type': 'news',
         'data-id': article.id
      });
      rstr += d[0].outerHTML;
      $('#mainin').stop(true).html(rstr).removeClass('leftout');
      //dn.pageScrollBar();
      $('#page').scrollTop(0);
      dn.checkStamps();
      this.initLinks();
      if (dn.curpage.update) {
         dn.curpage.html = $('#mainin').html();
      }
      if (dn.olddroid) {
         $('img').each(function () {
            if ($(this).attr('data-type') == "article") {
               $(this).attr('src', $(this).attr('data-stamp'));
            }
         })
      }
      $('button.share').click(function () {
         window.plugins.socialsharing.share($(this).attr('title'), $(this).attr('title'), null, $(this).attr('data-url'));
      })
      $('#header .share').attr('title', article.title);
      $('#header .share').attr('data-url', $('button.share').attr('data-url'));
      $('#header .share').unbind().click(function () {
         window.plugins.socialsharing.share($(this).attr('title'), $(this).attr('title'), null, $(this).attr('data-url'));
      })
   },
   artStampsCache: new Array(),
   checkArtStamp: function (id) {
      if (dn.artStampsCache[id]) {
         $('.ast' + id).attr('src', dn.artStampsCache[id]).addClass('loaded');
      } else
         dn.saveStamp('article', id, $('.ast' + id).attr('data-stamp'));
   },
   getArtStampSQL: function (d, v, od) {
      if (d.rows.length == 1) {
         var n = d.rows.item(0);
         if (n.lstamp) {
            dn.artStampsCache[id] = n.lstamp;
            $('.ast' + n.id).attr('src', n.lstamp).addClass('loaded');
         } else {
            dn.saveStamp('article', n.id, n.stamp);
         }
      } else {
         //console.log(od);
         dn.saveStamp('article', od.id, od.stamp);
      }
   },
   fts: new Array(),
   curft: false,
   saveStamp: function (dtype, id, stamp, force) {
      //console.log('SaveStamp ' + stamp);
      if (stamp) {
         if (force)
            dn.fts = new Array();
         dn.fts[dn.fts.length] = {
            stamp: stamp,
            type: dtype,
            id: id
         }
         dn.getStamp();
      }
   },
   getStamp: function () {
      if (!dn.curft) {
         dn.curft = dn.fts.shift();
         try {
            dn.fileSystem.root.getFile('Android/data/com.domenet.drtihanyicom/' + dn.curft.type + '_' + dn.curft.id, {create: true}, function (f) {
               var furl = f.toURL();
               dn.curft.url = furl;
               f.remove();
               dn.fileTransfer = new FileTransfer();
               dn.fileTransfer.download(dn.curft.stamp, furl, dn.gotStamp, dn.gotStamp);
            }, dn.cb);
         } catch (e) {
            dn.gotStamp({'fullPath': false});
         }
         ;
      }
   },
   gotStamp: function (f) {
      if (f.fullPath) {
         $('.ast' + dn.curft.id).attr('src', dn.curft.url).addClass('loaded');
         dn.artStampsCache[dn.curft.id] = dn.curft.url;
         db.update('news', {'lstamp': dn.curft.url}, 'id = ?', Array(dn.curft.id));
      } else {
         $('.ast' + dn.curft.id).attr('src', dn.curft.stamp).addClass('loaded');
         dn.artStampsCache[dn.curft.id] = dn.curft.stamp;
         db.update('news', {'lstamp': dn.curft.stamp}, 'id = ?', Array(dn.curft.id));
      }
      dn.curft = false;
      if (dn.fts.length > 0)
         dn.getStamp();
      else
         dn.fts = new Array();
   },
   checkStamps: function () {
      dn._cst = false;
      if (dn.olddroid) {
         $('img').each(function () {
            if ($(this).attr('data-type') == "article") {
               $(this).attr('src', $(this).attr('data-stamp'));
            }
         })
      } else {
         $('img:not(.loaded)').each(function () {
            if ($(this).attr('data-type') == "article") {
               dn.checkArtStamp($(this).attr('data-id'));
            }
         })
      }
      $('img').bind('error', function () {
         $(this).attr('src', $(this).attr('data-stamp'));
      })
   },
   page: function (type, id) {

   },
   pageDisp: function (id) {

   }
}

function _ts() {
   return new Date().getTime();
}

db = {
   toinsert: new Array(),
   toget: new Array(),
   toupdate: new Array(),
   ver: 2,
   init: function () {
      db._db = window.openDatabase('testdb', '1.0', 'mdb', 20 * 1024 * 1024);
      db._db.transaction(db.initDB, db.errorCB, db.successCB);
      // db.get('news', 'id = ?',1,"alert(db.results)");
   },
   get: function (table, str, vals, cb, otherData) {
      var valstr = "";
      var values = Array();
      if (typeof vals === 'array' || typeof vals === "object")
         values = vals;
      else
         values[0] = vals;

      var curid = db.toget.length;
      db.toget[curid] = {
         table: table,
         valstr: str,
         values: values,
         cb: cb,
         curid: curid,
         otherData: otherData
      };
      db.results = false;
      db._db.transaction(db._get, db.getError);
   },
   nowget: false,
   _get: function (tx) {
      if (db.toget.length == 0 && !db.nowget)
         return false;
      db.nowget = db.toget.shift();
      if (dn.debug) {
         alert('SELECT * FROM ' + db.nowget.table + ' WHERE ' + db.nowget.valstr);
      }
      tx.executeSql('SELECT * FROM ' + db.nowget.table + ' WHERE ' + db.nowget.valstr, db.nowget.values, db.getSuccess, db.getError);
   },
   getSuccess: function (tx, results) {
      db.results = results;
      if (dn.debug) {
         //      console.log(results);
      }
      try {
         db.nowget.cb(results, db.nowget.values, db.nowget.otherData);
      } catch (e) {
      }
      ;
      db.nowget = false;
      if (db.toget.length > 0)
         db._db.transaction(db._get, db.getError);
      else {
         db.toget = new Array();
         if (db.toinsert.length > 0)
            db._db.transaction(db._insert, db.errorCB, db.successCB);
      }
   },
   getError: function (tx, err) {
      db.results = false;
      try {
         db.nowget.cb(results);
      } catch (e) {
      }
      ;
      db.nowget = false;
      if (db.toget.length > 0)
         db._db.transaction(db._get, db.getError);
      else {
         db.toget = new Array();
         if (db.toinsert.length > 0)
            db._db.transaction(db._insert, db.errorCB, db.successCB);
      }
   },
   settings: new Object(),
   reInitDB: function (tx) {
      tx.executeSql('DROP TABLE IF EXISTS news');
      tx.executeSql('DROP TABLE IF EXISTS news_catlab');
      tx.executeSql('DROP TABLE IF EXISTS news_catlab_index');
      tx.executeSql('DROP TABLE IF EXISTS datastatus');
      tx.executeSql('CREATE TABLE IF NOT EXISTS datastatus (id unique, updated)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news (id unique, body, description, author, time, title, approved, stamp, lstamp, shares, comments, uri_id)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news_catlab (id unique, name, uri_id, parent)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news_catlab_index (id unique, cid, nid)');
      db.insert('settings', {'id': 'dbver', 'value': db.ver});
   },
   _initDB: function (d) {
      for (var i = 0; i < d.rows.length; i++) {
         db.settings[d.rows.item(i).id] = d.rows.item(i).value;
      }
      if (db.settings.dbver !== db.ver) {
         db._db.transaction(db.reInitDB, db.errorCB, db.successCB);
      } else {
      }
      dn.settings = db.settings;
      dn.gotSettings();
   },
   initDB: function (tx) {
      tx.executeSql('CREATE TABLE IF NOT EXISTS settings (id unique, value)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS datastatus (id unique, updated)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news (id unique, body, description, author, time, title, approved, stamp, lstamp, shares, comments, uri_id)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news_catlab (id unique, name, uri_id, parent)');
      tx.executeSql('CREATE TABLE IF NOT EXISTS news_catlab_index (id unique, cid, nid)');
      db._inittx = tx;
      db.get('settings', 1, Array(), db._initDB);
   },
   errorCB: function (tx, err) {
   },
   successCB: function (tx, d) {
   },
   insertOrUpdate: function (table, data, cb) {
      this.insert(table, data, db.insertOrUpdateCB, {"cb": cb});
   },
   insertOrUpdateCB: function (tx, res) {
      if (res.affectedRows == 0) {
      }
   },
   toupdate: new Array(),
           curupdate: false,
   update: function (table, data, str, vals, cb, otherData) {
      this.toupdate[this.toupdate.length] = {
         table: table,
         data: data,
         str: str,
         vals: vals,
         cb: cb,
         otherData: otherData
      };
      this._update();
   },
   _update: function () {
      if (!db.curupdate && db.toupdate.length > 0) {
         db.curupdate = db.toupdate.shift();
         db.get(db.curupdate.table, db.curupdate.str, db.curupdate.vals, db.gotUpdateData);
      }
   },
   gotUpdateData: function (res) {
      if (res.rows.length == 1) {
         var d = $.extend({}, res.rows.item(0), db.curupdate.data);
         db.insert(db.curupdate.table, d, db.updateSuccess);
      } else {
         db.insert(db.curupdate.table, db.curupdate.data, db.updateSuccess);
      }
   },
   updateSuccess: function (res) {
      try {
         db.curupdate.cb(res, db.curupdate.otherData);
      } catch (e) {
      }
      ;
      db.curupdate = false;
      if (db.toupdate.length > 0)
         db._update();
      else {
         db.toupdate = new Array();
      }
   },
   insert: function (table, data, cb, otherData) {
      if (!otherData)
         otherData = {};
      var fields = "";
      var valstr = "";
      var values = Array();
      $.each(data, function (index, value) {
         fields += ", " + index;
         valstr += ", ?";
         values[values.length] = value;
      });
      var curid = this.toinsert.length;
      db.toinsert[curid] = {
         table: table,
         fields: fields.substr(2),
         valstr: valstr.substr(2),
         values: values,
         cb: cb,
         otherData: otherData,
         curid: curid
      };
      db._db.transaction(db._insert, db.errorCB, db.successCB);
   },
   _insert: function (tx) {
      if (db.toget.length > 0 && db.toupdate.length == 0) {
         db._db.transaction(db._get, db.getError);
         return 0;
      }
      if (db.toinsert.length == 0 || db._inserted)
         return false;
      db._inserted = db.toinsert.shift();
      if (dn.debug)
         alert('INSERT OR REPLACE INTO ' + db._inserted.table + ' (' + db._inserted.fields + ') VALUES (' + db._inserted.valstr + ')');
      tx.executeSql('INSERT OR REPLACE INTO ' + db._inserted.table + ' (' + db._inserted.fields + ') VALUES (' + db._inserted.valstr + ')', db._inserted.values, db.insertcb, db.insertError);
   },
   insertcb: function (tx, data) {
      try {
         db._inserted.cb(tx, data, db._inserted.otherData);
      } catch (e) {
      }
      ;
      db._inserted = false;
      if (db.toget.length > 0 && db.toupdate.length == 0)
         return db._db.transaction(db._get, db.getError);
      if (db.toinsert.length > 0)
         db._db.transaction(db._insert, db.errorCB, db.successCB);
      else {
         db.toinsert = new Array();
      }
   },
   insertError: function (e, err) {
      db._inserted = false;
      if (db.toinsert.length > 0)
         db._db.transaction(db._insert, db.errorCB, db.successCB);
      else
         db.toinsert = new Array();
   }
}


var touches = {
   sy: 0,
   sx: 0,
   ts: 0,
   sr: null,
   sl: null,
   sd: null,
   stopped: 0,
   dlength: 150,
   lmtop: 0,
   start: function (e) {
      if (e.touches) {
         touches.sx = e.touches[0].clientX;
         touches.sy = e.touches[0].clientY;
      } else if (e.pageX) {
         touches.sx = e.pageX;
         touches.sy = e.pageY;
      } else {
         touches.sx = e.clientX;
         touches.sy = e.clientY;
      }
      touches.fdir = false;
      touches.stopped = false;
      touches.ts = _ts();
   },
   move: function (e) {
      if (touches.stopped)
         return true;
      if (e.changedTouches) {
         x = e.changedTouches[0].clientX;
         y = e.changedTouches[0].clientY;
      } else if (e.pageX) {
         x = e.pageX;
         y = e.pageY;
      } else {
         x = e.clientX;
         y = e.clientY;
      }
      if ((x > touches.sx + 3 || x < touches.sx - 3) && (y > touches.sy - 10 && y < touches.sy + 10)) {
         if (x > touches.sx + 10 && !touches.fdir) {
            touches.fdir = "right";
         }
         if (x < touches.sx - 10 && !touches.fdir && touches.sx < 10) {
            touches.fdir = "left";
         }
         if (x > touches.sx + 30 && touches.fdir == "right" && touches.sx < 10) {
            touches.stopped = true;
            touches.sright();
         } else if (x < touches.sx - 30 && touches.fdir == "left") {
            touches.stopped = true;
            touches.sleft();
         }
         if (x > touches.sx + 5 || x < touches.sx - 5)
            e.preventDefault();
      } else if (y > touches.sy + 1) {
         if (y > touches.sy + 10 && !touches.fdir)
            touches.fdir = "down";
         if (y > touches.sy + 30 && touches.fdir == "down") {
            touches.stopped = true;
            touches.sdown();
         }
         //e.preventDefault();
      } else
         touches.stopped = true;
   },
   end: function (e) {
      if (touches.stopped)
         return true;
      var ts = _ts();
      if (e.changedTouches) {
         x = e.changedTouches[0].clientX;
         y = e.changedTouches[0].clientY;
      } else if (e.pageX) {
         x = e.pageX;
         y = e.pageY;
      } else {
         x = e.clientX;
         y = e.clientY;
      }
      
      if (!touches.fdir) {
         touches.fdir = "right";
         var xdiff = x - touches.sx;
         if (x < touches.sx) {
            touches.fdir = "left";
            xdiff = touches.sx - x;
         }
         if (y - touches.sy > xdiff)
            touches.fdir = "down";
      }

      if (x > touches.sx + 50 && touches.fdir == "right" && touches.sx < 10) {
         touches.sright();
      } else if (x < touches.sx - 50 && touches.fdir == "left") {
         touches.sleft();
      } else if (y > touches.sy + 50 && touches.fdir == "down") {
         touches.sdown();
      }

      touches.stopped = false;
      touches.fdir = false;
   },
   sright: function () {
      try {
         touches.sr();
      } catch (e) {
         //      console.log(e)
      }
      ;
   },
   sleft: function () {
      try {
         touches.sl();
      } catch (e) {
         //      console.log(e)
      }
      ;
   },
   sdown: function () {
     /* try {
         touches.sd();
      } catch (e) {
         //      console.log(e)
      }
      ;*/
   }
}

$(document).ready(function () {
   dn.docready = 1;
   dn.init();
})
dn.startAppTime = _ts();
